commit 3adceba04eddf8c6e21fda3f7d0f8015e17bf5d8
Author: Gaius Mulley <gaiusmod2@gmail.com>
Date:   Fri Nov 22 18:38:51 2024 +0000

    [PATCH] PR modula2/115536 Expression is evaluated incorrectly when encountering relops and indirection
    
    This fix ensures that we only call BuildRelOpFromBoolean if we are
    inside a constant expression (where no indirection can be used).
    The fix creates a temporary variable when a boolean is created from
    a relop in other cases.
    The previous pattern implementation would not work if the operands required
    dereferencing during non const expressions.  Comparison of relop results
    in a constant expression are resolved by constant propagation, basic
    block analysis and dead code removal.  After the quadruples have been
    optimized only one assignment to the boolean variable will remain for
    const expressions.  All quadruple pattern checking for boolean
    expressions is removed by the patch.  Thus the implementation becomes
    more generic.
    
    gcc/m2/ChangeLog:
    
            PR modula2/115536
            * gm2-compiler/M2BasicBlock.def (GetBasicBlockScope): New procedure.
            (GetBasicBlockStart): Ditto.
            (GetBasicBlockEnd): Ditto.
            (IsBasicBlockFirst): New procedure function.
            * gm2-compiler/M2BasicBlock.mod (ConvertQuads2BasicBlock): Allow
            conditional boolean quads to be removed.
            (GetBasicBlockScope): Implement new procedure.
            (GetBasicBlockStart): Ditto.
            (GetBasicBlockEnd): Ditto.
            (IsBasicBlockFirst): Implement new procedure function.
            * gm2-compiler/M2GCCDeclare.def (FoldConstants): New parameter
            declaration.
            * gm2-compiler/M2GCCDeclare.mod (FoldConstants): New parameter
            declaration.
            (DeclareTypesConstantsProceduresInRange): Recreate basic blocks
            after resolving constant expressions.
            (CodeBecomes): Guard IsVariableSSA with IsVar.
            * gm2-compiler/M2GenGCC.def (ResolveConstantExpressions): New
            parameter declaration.
            * gm2-compiler/M2GenGCC.mod (FoldIfLess): Remove relop pattern
            detection.
            (FoldIfGre): Ditto.
            (FoldIfLessEqu): Ditto.
            (FoldIfGreEqu): Ditto.
            (FoldIfIn): Ditto.
            (FoldIfNotIn): Ditto.
            (FoldIfEqu): Ditto.
            (FoldIfNotEqu): Ditto.
            (FoldBecomes): Add BasicBlock parameter and allow conditional
            boolean becomes to be folded in the first basic block.
            (ResolveConstantExpressions): Reimplement.
            * gm2-compiler/M2Quads.def (IsConstQuad): New procedure function.
            (IsConditionalBooleanQuad): Ditto.
            * gm2-compiler/M2Quads.mod (IsConstQuad): Implement new procedure function.
            (IsConditionalBooleanQuad): Ditto.
            (MoveWithMode): Use GenQuadOTypetok.
            (IsInitialisingConst): Rewrite using OpUsesOp1.
            (OpUsesOp1): New procedure function.
            (doBuildAssignment): Mark des as a VarConditional.
            (ConvertBooleanToVariable): Call PutVarConditional.
            (DumpQuadSummary): New procedure.
            (BuildRelOpFromBoolean): Updated debugging and improved comments.
            (BuildRelOp): Only call BuildRelOpFromBoolean if we are in a const
            expression and both operands are boolean relops.
            (GenQuadOTypeUniquetok): New procedure.
            (BackPatch): Correct comment.
            * gm2-compiler/SymbolTable.def (PutVarConditional): New procedure.
            (IsVarConditional): New procedure function.
            * gm2-compiler/SymbolTable.mod (PutVarConditional): Implement new
            procedure.
            (IsVarConditional): Implement new procedure function.
            (SymConstVar): New field IsConditional.
            (SymVar): New field IsConditional.
            (MakeVar): Initialize IsConditional field.
            (MakeConstVar): Initialize IsConditional field.
            * gm2-compiler/M2Swig.mod (DoBasicBlock): Change parameters to
            use BasicBlock.
            * gm2-compiler/M2Code.mod (SecondDeclareAndOptimize): Use iterator
            to FoldConstants over basic block list.
            * gm2-compiler/M2SymInit.mod (AppendEntry): Replace parameters
            with BasicBlock.
            * gm2-compiler/P3Build.bnf (Relation): Call RecordOp for #, <> and =.
    
    gcc/testsuite/ChangeLog:
    
            PR modula2/115536
            * gm2/iso/const/pass/constbool4.mod: New test.
            * gm2/iso/const/pass/constbool5.mod: New test.
            * gm2/iso/run/pass/condtest2.mod: New test.
            * gm2/iso/run/pass/condtest3.mod: New test.
            * gm2/iso/run/pass/condtest4.mod: New test.
            * gm2/iso/run/pass/condtest5.mod: New test.
            * gm2/iso/run/pass/constbool4.mod: New test.
    
    (cherry picked from commit 9f168b412f44781013401492acfedf22afe7741b)
    
    Signed-off-by: Gaius Mulley <gaiusmod2@gmail.com>

diff --git a/gcc/m2/gm2-compiler/M2BasicBlock.def b/gcc/m2/gm2-compiler/M2BasicBlock.def
index 7387ae69c4d..54b2ec48293 100644
--- a/gcc/m2/gm2-compiler/M2BasicBlock.def
+++ b/gcc/m2/gm2-compiler/M2BasicBlock.def
@@ -32,15 +32,11 @@ DEFINITION MODULE M2BasicBlock ;
 *)
 
 FROM M2Scope IMPORT ScopeBlock ;
-EXPORT QUALIFIED BasicBlock, BasicBlockProc,
-                 InitBasicBlocks, InitBasicBlocksFromRange,
-		 KillBasicBlocks, FreeBasicBlocks,
-                 ForeachBasicBlockDo ;
 
 
 TYPE
    BasicBlock ;
-   BasicBlockProc = PROCEDURE (CARDINAL, CARDINAL) ;
+   BasicBlockProc = PROCEDURE (BasicBlock) ;
 
 
 (*
@@ -85,4 +81,32 @@ PROCEDURE FreeBasicBlocks (bb: BasicBlock) ;
 PROCEDURE ForeachBasicBlockDo (bb: BasicBlock; p: BasicBlockProc) ;
 
 
+(*
+   GetBasicBlockScope - return the scope associated with the basic block.
+*)
+
+PROCEDURE GetBasicBlockScope (bb: BasicBlock) : CARDINAL ;
+
+
+(*
+   GetBasicBlockStart - return the quad associated with the start of the basic block.
+*)
+
+PROCEDURE GetBasicBlockStart (bb: BasicBlock) : CARDINAL ;
+
+
+(*
+   GetBasicBlockEnd - return the quad associated with the end of the basic block.
+*)
+
+PROCEDURE GetBasicBlockEnd (bb: BasicBlock) : CARDINAL ;
+
+
+(*
+   IsBasicBlockFirst - return TRUE if this basic block is the first in the sequence.
+*)
+
+PROCEDURE IsBasicBlockFirst (bb: BasicBlock) : BOOLEAN ;
+
+
 END M2BasicBlock.
diff --git a/gcc/m2/gm2-compiler/M2BasicBlock.mod b/gcc/m2/gm2-compiler/M2BasicBlock.mod
index f4b9cb021c8..96dc649965a 100644
--- a/gcc/m2/gm2-compiler/M2BasicBlock.mod
+++ b/gcc/m2/gm2-compiler/M2BasicBlock.mod
@@ -32,7 +32,7 @@ FROM M2Quads IMPORT IsReferenced, IsConditional, IsUnConditional, IsCall,
                     IsReturn, IsNewLocalVar, IsKillLocalVar,
                     IsCatchBegin, IsCatchEnd,
                     IsInitStart, IsInitEnd, IsFinallyStart, IsFinallyEnd,
-                    IsInitialisingConst,
+                    IsInitialisingConst, IsConditionalBooleanQuad,
                     IsPseudoQuad, IsDefOrModFile,
                     GetNextQuad, GetQuad, QuadOperator,
                     SubQuad, DisplayQuadRange ;
@@ -45,10 +45,11 @@ CONST
 
 TYPE
    BasicBlock = POINTER TO RECORD
-                   StartQuad  : CARDINAL ;  (* First Quad in Basic Block *)
-                   EndQuad    : CARDINAL ;  (* End Quad in Basic Block   *)
+                   Scope      : CARDINAL ;  (* Scope associated with the block.  *)
+                   StartQuad  : CARDINAL ;  (* First Quad in Basic Block.  *)
+                   EndQuad    : CARDINAL ;  (* End Quad in Basic Block.  *)
+                   First      : BOOLEAN ;   (* The first block?  *)
                    Right      : BasicBlock ;
-                                            (* Last Basic Block in list  *)
                    Left       : BasicBlock ;
                 END ;
 
@@ -57,6 +58,10 @@ VAR
    HeadOfBasicBlock: BasicBlock ;
 
 
+PROCEDURE stop ;
+END stop ;
+
+
 (*
    InitBasicBlocks - converts a list of quadruples as defined by
                      scope blocks into a set of basic blocks.
@@ -128,19 +133,21 @@ END FreeBasicBlocks ;
    New - returns a basic block.
 *)
 
-PROCEDURE New () : BasicBlock ;
+PROCEDURE New (Scope: CARDINAL; First: BOOLEAN) : BasicBlock ;
 VAR
    b: BasicBlock ;
 BEGIN
    IF FreeList=NIL
    THEN
-      NEW(b)
+      NEW (b)
    ELSE
       b := FreeList ;
       FreeList := FreeList^.Right
    END ;
-   Assert(b#NIL) ;
-   RETURN( b )
+   Assert (b#NIL) ;
+   b^.Scope := Scope ;
+   b^.First := First ;
+   RETURN b
 END New ;
 
 
@@ -153,6 +160,7 @@ END New ;
 
 PROCEDURE ConvertQuads2BasicBlock (ScopeSym: CARDINAL; Start, End: CARDINAL) ;
 VAR
+   First,
    LastQuadDefMod,
    LastQuadConditional,
    LastQuadCall,
@@ -163,13 +171,14 @@ VAR
 BEGIN
    IF Debugging
    THEN
+      WriteString ("Enter ConvertQuads2BasicBlock") ; WriteLn ;
       DisplayQuadRange (ScopeSym, Start, End)
    END ;
    (*
       Algorithm to perform Basic Block:
 
       For every quadruple establish a set of leaders.
-      A Leader is defined as a quadruple which is
+      A leader is defined as a quadruple which is
       either:
 
       (i)   The first quadruple.
@@ -179,7 +188,7 @@ BEGIN
       For each leader construct a basic block.
       A Basic Block starts with a leader quadruple and ends with either:
 
-      (i)  Another Leader
+      (i)  Another leader
       (ii) An unconditional Jump.
 
       Any quadruples that do not fall into a Basic Block can be thrown away
@@ -188,20 +197,26 @@ BEGIN
    LastBB := NIL ;
    CurrentBB := NIL ;
    Quad := Start ;
-   LastQuadConditional := TRUE ;  (* Force Rule (i) *)
+   LastQuadConditional := TRUE ;  (* Force Rule (i).  *)
    LastQuadCall := FALSE ;
    LastQuadReturn := FALSE ;
    LastQuadDefMod := FALSE ;
-   (* Scan all quadruples *)
+   First := TRUE ;
+   (* Scan all quadruples.  *)
    WHILE (Quad<=End) AND (Quad#0) DO
+      IF Quad = 200
+      THEN
+         stop
+      END ;
       IF LastQuadConditional OR LastQuadCall OR LastQuadReturn OR
          LastQuadDefMod OR IsReferenced(Quad)
       THEN
          (* Rule (ii) *)
-         CurrentBB := New() ;                      (* Get a new Basic Block *)
-                                  (* At least one quad in this Basic Block  *)
+         CurrentBB := New (ScopeSym, First) ;  (* Get a new Basic Block.  *)
+                                 (* At least one quad in this Basic Block.  *)
          StartBB(CurrentBB, Quad) ;
-         EndBB(CurrentBB, Quad)
+         EndBB(CurrentBB, Quad) ;
+         First := FALSE
       ELSIF CurrentBB#NIL
       THEN
          (* We have a Basic Block - therefore add quad to this Block  *)
@@ -216,14 +231,20 @@ BEGIN
             IsInitStart(Quad) OR IsInitEnd(Quad) OR
             IsFinallyStart(Quad) OR IsFinallyEnd(Quad)
       THEN
-         (* we must leave these quads alone *)
+         (* We must leave these quads alone.  *)
          EndBB(LastBB, Quad)
+      ELSIF IsConditionalBooleanQuad (Quad)
+      THEN
+         (* We can remove unreachable const quads.  *)
+         SubQuad (Quad)
+(*
       ELSIF IsInitialisingConst(Quad)
       THEN
-         (* we must leave these quads alone *)
+         (* But we leave remaining constant quads alone.  *)
          EndBB(LastBB, Quad)
+*)
       ELSE
-         (* remove this Quad since it will never be reached *)
+         (* Remove this Quad since it will never be reached.  *)
          SubQuad(Quad)
       END ;
       LastQuadConditional := IsConditional(Quad) ;
@@ -236,12 +257,17 @@ BEGIN
          CurrentBB := NIL
       END ;
       Quad := GetNextQuad(Quad)
+   END ;
+   IF Debugging
+   THEN
+      WriteString ("Exit ConvertQuads2BasicBlock") ; WriteLn ;
+      DisplayQuadRange (ScopeSym, Start, End)
    END
 END ConvertQuads2BasicBlock ;
 
 
 (*
-   ForeachBasicBlockDo - for each basic block call procedure, p.
+   ForeachBasicBlockDo - for each basic block call procedure  p.
 *)
 
 PROCEDURE ForeachBasicBlockDo (bb: BasicBlock; p: BasicBlockProc) ;
@@ -253,7 +279,7 @@ BEGIN
       b := bb ;
       REPEAT
          WITH b^ DO
-            p (StartQuad, EndQuad)
+            p (b)
          END ;
          b := b^.Right
       UNTIL b=bb
@@ -307,29 +333,6 @@ BEGIN
 END Add ;
 
 
-(*
-   Sub deletes an element from the specified queue.
-*)
-
-(*
-PROCEDURE Sub (VAR Head: BasicBlock;
-               b: BasicBlock) ;
-BEGIN
-   IF (b^.Right=Head) AND (b=Head)
-   THEN
-      Head := NIL
-   ELSE
-      IF Head=b
-      THEN
-         Head := Head^.Right
-      END ;
-      b^.Left^.Right := b^.Right ;
-      b^.Right^.Left := b^.Left
-   END
-END Sub ;
-*)
-
-
 (*
    DisplayBasicBlocks - displays the basic block data structure.
 *)
@@ -359,6 +362,46 @@ BEGIN
 END DisplayBlock ;
 
 
+(*
+   GetBasicBlockScope - return the scope associated with the basic block.
+*)
+
+PROCEDURE GetBasicBlockScope (bb: BasicBlock) : CARDINAL ;
+BEGIN
+   RETURN bb^.Scope
+END GetBasicBlockScope ;
+
+
+(*
+   GetBasicBlockStart - return the quad associated with the start of the basic block.
+*)
+
+PROCEDURE GetBasicBlockStart (bb: BasicBlock) : CARDINAL ;
+BEGIN
+   RETURN bb^.StartQuad
+END GetBasicBlockStart ;
+
+
+(*
+   GetBasicBlockEnd - return the quad associated with the end of the basic block.
+*)
+
+PROCEDURE GetBasicBlockEnd (bb: BasicBlock) : CARDINAL ;
+BEGIN
+   RETURN bb^.EndQuad
+END GetBasicBlockEnd ;
+
+
+(*
+   IsBasicBlockFirst - return TRUE if this basic block is the first in the sequence.
+*)
+
+PROCEDURE IsBasicBlockFirst (bb: BasicBlock) : BOOLEAN ;
+BEGIN
+   RETURN bb^.First
+END IsBasicBlockFirst ;
+
+
 BEGIN
    FreeList := NIL
 END M2BasicBlock.
diff --git a/gcc/m2/gm2-compiler/M2Code.mod b/gcc/m2/gm2-compiler/M2Code.mod
index f8a773dc103..ea86232c714 100644
--- a/gcc/m2/gm2-compiler/M2Code.mod
+++ b/gcc/m2/gm2-compiler/M2Code.mod
@@ -320,9 +320,14 @@ END InitialDeclareAndOptimize ;
 
 PROCEDURE SecondDeclareAndOptimize (scope: CARDINAL;
                                     start, end: CARDINAL) ;
+VAR
+   bb: BasicBlock ;
 BEGIN
    REPEAT
-      FoldConstants(start, end) ;
+      bb := InitBasicBlocksFromRange (scope, start, end) ;
+      ForeachBasicBlockDo (bb, FoldConstants) ;
+      FreeBasicBlocks (bb) ;
+
       DeltaConst := Count - CountQuads () ;
       Count := CountQuads () ;
 
diff --git a/gcc/m2/gm2-compiler/M2GCCDeclare.def b/gcc/m2/gm2-compiler/M2GCCDeclare.def
index 28bbb1a41b5..13570dabfbb 100644
--- a/gcc/m2/gm2-compiler/M2GCCDeclare.def
+++ b/gcc/m2/gm2-compiler/M2GCCDeclare.def
@@ -32,6 +32,7 @@ DEFINITION MODULE M2GCCDeclare ;
 
 FROM SYSTEM IMPORT WORD ;
 FROM m2tree IMPORT Tree ;
+FROM M2BasicBlock IMPORT BasicBlock ;
 
 TYPE
    WalkAction = PROCEDURE (WORD) ;
@@ -42,7 +43,7 @@ TYPE
    FoldConstants - a wrapper for ResolveConstantExpressions.
 *)
 
-PROCEDURE FoldConstants (start, end: CARDINAL) ;
+PROCEDURE FoldConstants (bb: BasicBlock) ;
 
 
 (*
diff --git a/gcc/m2/gm2-compiler/M2GCCDeclare.mod b/gcc/m2/gm2-compiler/M2GCCDeclare.mod
index 9607085b967..a2effe97b66 100644
--- a/gcc/m2/gm2-compiler/M2GCCDeclare.mod
+++ b/gcc/m2/gm2-compiler/M2GCCDeclare.mod
@@ -71,6 +71,8 @@ FROM Sets IMPORT Set, InitSet, KillSet,
                  NoOfElementsInSet, IsElementInSet, ForeachElementInSetDo,
                  DuplicateSet, EqualSet ;
 
+FROM M2BasicBlock IMPORT BasicBlock, InitBasicBlocks, KillBasicBlocks, ForeachBasicBlockDo ;
+
 FROM SymbolTable IMPORT NulSym,
                         ModeOfAddr,
                         GetMode,
@@ -252,6 +254,7 @@ VAR
    WatchList           : Set ;      (* Set of symbols being watched.  *)
    EnumerationIndex    : Index ;
    action              : IsAction ;
+   ConstantResolved,
    enumDeps            : BOOLEAN ;
 
 
@@ -1296,30 +1299,6 @@ BEGIN
 END DeclareTypeFromPartial ;
 
 
-(*
-   DeclarePointerTypeFully - if, sym, is a pointer type then
-                             declare it.
-*)
-
-(*
-PROCEDURE DeclarePointerTypeFully (sym: CARDINAL) ;
-BEGIN
-   IF IsPointer(sym)
-   THEN
-      WatchIncludeList(sym, fullydeclared) ;
-      WatchRemoveList(sym, partiallydeclared) ;
-      WatchRemoveList(sym, todolist) ;
-      PreAddModGcc(sym, DeclarePointer(sym))
-   ELSE
-      (* place sym and all dependants on the todolist
-         providing they are not already on the FullyDeclared list
-      *)
-      TraverseDependants(sym)
-   END
-END DeclarePointerTypeFully ;
-*)
-
-
 (*
    CanBeDeclaredPartiallyViaPartialDependants - returns TRUE if, sym,
                                                 can be partially declared via
@@ -1476,22 +1455,6 @@ BEGIN
                             DeclareTypePartially)
       THEN
          (* continue looping *)
-(*
-      ELSIF ForeachTryDeclare (todolist,
-                               setarraynul,
-                               CanCreateSetArray,
-                               CreateSetArray)
-      THEN
-         (* Populates the finishedsetarray list with each set seen.  *)
-         (* Continue looping.  *)
-      ELSIF ForeachTryDeclare (finishedsetarray,
-                               setfully,
-                               CanCreateSet,
-                               CreateSet)
-      THEN
-         (* Populates the fullydeclared list with each set.  *)
-         (* Continue looping.  *)
-*)
       ELSIF ForeachTryDeclare (todolist,
                                arraynil,
                                CanDeclareArrayAsNil,
@@ -1902,25 +1865,15 @@ BEGIN
       IF (type#NulSym) AND (NOT CompletelyResolved(type))
       THEN
          TraverseDependants(sym) ;
-(*
-         WatchIncludeList(sym, todolist) ;
-         WatchIncludeList(type, todolist) ;
-*)
          RETURN
       END ;
       IF IsConstructor(sym) AND (NOT IsConstructorConstant(sym))
       THEN
          TraverseDependants(sym) ;
-(*
-         WatchIncludeList(sym, todolist) ;
-*)
          RETURN
       END ;
       IF (IsConstructor(sym) OR IsConstSet(sym)) AND (type=NulSym)
       THEN
-(*
-         WatchIncludeList(sym, todolist) ;
-*)
          TraverseDependants(sym) ;
          RETURN
       END ;
@@ -1936,10 +1889,7 @@ BEGIN
          THEN
             RETURN
          END ;
-         TraverseDependants(sym) ;
-(*
-         WatchIncludeList(sym, todolist)
-*)
+         TraverseDependants(sym)
       ELSE
          TryDeclareConst(tokenno, sym)
       END
@@ -2011,9 +1961,6 @@ BEGIN
          TryEvaluateValue(sym) ;
          IF NOT IsConstructorDependants(sym, IsFullyDeclared)
          THEN
-(*
-            WatchIncludeList(sym, todolist) ;
-*)
             TraverseDependants(sym) ;
             RETURN
          END ;
@@ -2161,38 +2108,6 @@ BEGIN
 END WalkAssociatedUnbounded ;
 
 
-(*
-   WalkProcedureParameterDependants -
-*)
-
-(*
-PROCEDURE WalkProcedureParameterDependants (sym: CARDINAL; p: WalkAction) ;
-VAR
-   son,
-   type,
-   n, i: CARDINAL ;
-BEGIN
-   IF IsProcedure(sym)
-   THEN
-      n := NoOfParam(sym) ;
-      i := n ;
-      WHILE i>0 DO
-         IF IsUnboundedParam(sym, i)
-         THEN
-            son := GetNthParam(sym, i)
-         ELSE
-            son := GetNth(sym, i) ;
-         END ;
-         type := GetSType(son) ;
-         p(type) ;
-         WalkDependants(type, p) ;
-         DEC(i)
-      END
-   END
-END WalkProcedureParameterDependants ;
-*)
-
-
 (*
    WalkDependants - walks through all dependants of, Sym,
                     calling, p, for each dependant.
@@ -2723,10 +2638,11 @@ END DeclareProcedure ;
    FoldConstants - a wrapper for ResolveConstantExpressions.
 *)
 
-PROCEDURE FoldConstants (start, end: CARDINAL) ;
+PROCEDURE FoldConstants (bb: BasicBlock) ;
 BEGIN
-   IF ResolveConstantExpressions(DeclareConstFully, start, end)
+   IF ResolveConstantExpressions (DeclareConstFully, bb)
    THEN
+      ConstantResolved := TRUE
    END
 END FoldConstants ;
 
@@ -2778,6 +2694,8 @@ CONST
 VAR
    copy: Group ;
    loop: CARDINAL ;
+   sb  : ScopeBlock ;
+   bb  : BasicBlock ;
 BEGIN
    IF TraceQuadruples
    THEN
@@ -2785,11 +2703,18 @@ BEGIN
    END ;
    loop := 0 ;
    copy := NIL ;
+   sb := InitScopeBlock (scope) ;
    REPEAT
+      (* Throw away any unreachable quad.  *)
+      bb := InitBasicBlocks (sb) ;
+      KillBasicBlocks (bb) ;
+      (* Now iterate over remaining quads in scope attempting to resolve constants.  *)
       copy := DupGroup (copy) ;
-      WHILE ResolveConstantExpressions (DeclareConstFully, start, end) DO
-      END ;
-      (* we need to evaluate some constant expressions to resolve these types *)
+      bb := InitBasicBlocks (sb) ;
+      ConstantResolved := FALSE ;
+      ForeachBasicBlockDo (bb, FoldConstants) ;
+      KillBasicBlocks (bb) ;
+      (* And now types.  *)
       IF DeclaredOutstandingTypes (FALSE)
       THEN
       END ;
@@ -2803,9 +2728,11 @@ BEGIN
          loop := 0
       END ;
       INC (loop)
-   UNTIL (NOT ResolveConstantExpressions (DeclareConstFully, start, end)) AND
-         EqualGroup (copy, GlobalGroup) ;
-   KillGroup (copy)
+   UNTIL (NOT ConstantResolved) AND EqualGroup (copy, GlobalGroup) ;
+   KillGroup (copy) ;
+   bb := InitBasicBlocks (sb) ;
+   KillBasicBlocks (bb) ;
+   KillScopeBlock (sb)
 END DeclareTypesConstantsProceduresInRange ;
 
 
@@ -5990,33 +5917,6 @@ BEGIN
 END WalkRecordFieldDependants ;
 
 
-(*
-   WalkVarient -
-*)
-
-(*
-PROCEDURE WalkVarient (sym: CARDINAL; p: WalkAction) ;
-VAR
-   v    : CARDINAL ;
-   var,
-   align: CARDINAL ;
-BEGIN
-   p(sym) ;
-   v := GetVarient(sym) ;
-   IF v#NulSym
-   THEN
-      p(v)
-   END ;
-   var := GetRecordOfVarient(sym) ;
-   align := GetDefaultRecordFieldAlignment(var) ;
-   IF align#NulSym
-   THEN
-      p(align)
-   END
-END WalkVarient ;
-*)
-
-
 (*
    WalkRecordDependants2 - walks the fields of record, sym, calling
                            p on every dependant.
diff --git a/gcc/m2/gm2-compiler/M2GenGCC.def b/gcc/m2/gm2-compiler/M2GenGCC.def
index 3e4705ec235..fc7cdf281dd 100644
--- a/gcc/m2/gm2-compiler/M2GenGCC.def
+++ b/gcc/m2/gm2-compiler/M2GenGCC.def
@@ -34,10 +34,7 @@ DEFINITION MODULE M2GenGCC ;
 FROM M2GCCDeclare IMPORT WalkAction ;
 FROM m2tree IMPORT Tree ;
 FROM m2linemap IMPORT location_t ;
-EXPORT QUALIFIED ConvertQuadsToTree, ResolveConstantExpressions,
-                 GetHighFromUnbounded, StringToChar,
-                 LValueToGenericPtr, ZConstToTypedConst,
-                 PrepareCopyString ;
+FROM M2BasicBlock IMPORT BasicBlock ;
 
 
 (*
@@ -55,7 +52,7 @@ PROCEDURE ConvertQuadsToTree (Start, End: CARDINAL) ;
                                 p(sym) is invoked.
 *)
 
-PROCEDURE ResolveConstantExpressions (p: WalkAction; start, end: CARDINAL) : BOOLEAN ;
+PROCEDURE ResolveConstantExpressions (p: WalkAction; bb: BasicBlock) : BOOLEAN ;
 
 
 (*
